#include "StdAfx.h"

#include "ImageProxy.h"
#include "NSliderThumb.h"
#include "NToolTip.h"

IMPLEMENT_RTTI(CNSliderThumb, CNPanel)

CNSliderThumb::CNSliderThumb()
{
	m_pImage = NULL;
	m_pToolTip = NULL;
	this->AddPropertyChangedListener(this);
}

CNSliderThumb::~CNSliderThumb()
{
	this->RemovePropertyChangedListener(this);
}

void CNSliderThumb::SetImage( IImage* pImage )
{
	ATLASSERT(pImage);

	m_pImage = pImage;
}

void CNSliderThumb::DrawFocused(HDC hDC)
{
	if(	m_pImage && 
		this->GetFocus() == this)
	{
		CRect rcDest;
		this->GetClientRect(&rcDest);

		CRect rcSrc(0, 0, m_pImage->GetWidth() / 4, m_pImage->GetHeight());
		rcSrc.MoveToX(m_pImage->GetWidth() / 4);

		m_pImage->DrawImage(hDC, &rcSrc, &rcDest);
	}
}
void CNSliderThumb::OnPropertyChanged(CPropertyChangeEvent* pPropertyChangedEvent)
{
	if (m_pToolTip == NULL) return;

	BOOL bToolTipVisible = FALSE;
	if (_tcscmp(pPropertyChangedEvent->m_szPropertyName, ComponentProperty::MouseEnter) == 0)
	{
		bToolTipVisible = TRUE;
	}
	else if (_tcscmp(pPropertyChangedEvent->m_szPropertyName, ComponentProperty::MouseExit) == 0)
	{
		bToolTipVisible = FALSE;
	}
	m_pToolTip->SetVisible(bToolTipVisible);
}

void CNSliderThumb::SetToolTip( CNToolTip* pToolTip )
{
	// {kr} Է° ȿ ˻ {/kr}
	ATLASSERT(pToolTip != NULL);
	if(!(pToolTip != NULL)) return;

	m_pToolTip = pToolTip;
}